---
title: yield
slug: Web/JavaScript/Reference/Operators/yield
tags:
  - ECMAScript 2015
  - Generators
  - Iterator
  - JavaScript
  - Language feature
  - Operator
---
<div>{{jsSidebar("Operators")}}</div>

<p>The <code>yield</code> keyword is used to pause and resume a generator function ({{jsxref("Statements/function*", "function*")}} or <a href="/en-US/docs/Archive/Web/JavaScript/Legacy_generator_function_statement">legacy generator function</a>).</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-yield.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">[<var>rv</var>] = <strong>yield</strong> [<var>expression</var>]</pre>

<dl>
 <dt><code><var>expression</var></code> {{optional_inline}}</dt>
 <dd>Defines the value to return from the generator function via <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#The_iterator_protocol">the iterator protocol</a>. If omitted, <code>undefined</code> is returned instead.</dd>
 <dt><code><var>rv</var></code> {{optional_inline}}</dt>
 <dd>
 <p>Retrieves the optional value passed to the generator's <code>next()</code> method to resume its execution.</p>
 </dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>yield</code> keyword pauses generator function execution and the value of the expression following the <code>yield</code> keyword is returned to the generator's caller. It can be thought of as a generator-based version of the <code>return</code> keyword.</p>

<p><code>yield</code> can only be called directly from the generator function that contains it. It cannot be called from nested functions or from callbacks.</p>

<p>The <code>yield</code> keyword causes the call to the generator's <code>next()</code> method to return an <code>IteratorResult</code> object with two properties: <code>value</code> and <code>done</code>. The <code>value</code> property is the result of evaluating the <code>yield</code> expression, and <code>done</code> is <code>false</code>, indicating that the generator function has not fully completed.</p>

<p>Once paused on a <code>yield</code> expression, the generator's code execution remains paused until the generator's <code>next()</code> method is called. Each time the generator's <code>next()</code> method is called, the generator resumes execution, and runs until it reaches one of the following:</p>

<ul>
 <li>A <code>yield</code>, which causes the generator to once again pause and return the generator's new value. The next time <code>next()</code> is called, execution resumes with the statement immediately after the <code>yield</code>.</li>
 <li>{{jsxref("Statements/throw", "throw")}} is used to throw an exception from the generator. This halts execution of the generator entirely, and execution resumes in the caller (as is normally the case when an exception is thrown).</li>
 <li>The end of the generator function is reached. In this case, execution of the generator ends and an <code>IteratorResult</code> is returned to the caller in which the <code>value</code> is {{jsxref("undefined")}} and <code>done</code> is <code>true</code>.</li>
 <li>A {{jsxref("Statements/return", "return")}} statement is reached. In this case, execution of the generator ends and an <code>IteratorResult</code> is returned to the caller in which the <code>value</code> is the value specified by the <code>return</code> statement and <code>done</code> is <code>true</code>.</li>
</ul>

<p>If an optional value is passed to the generator's <code>next()</code> method, that value becomes the value returned by the generator's current <code>yield</code> operation.</p>

<p>Between the generator's code path, its <code>yield</code> operators, and the ability to specify a new starting value by passing it to {{jsxref("Generator.prototype.next()")}}, generators offer enormous power and control.</p>

<div class="notecard warning">
<p>Unfortunately, <code>next()</code> is asymmetric, but that can’t be helped: It always sends a value to the currently suspended <code>yield</code>, but returns the operand of the following <code>yield</code>.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Using_yield">Using yield</h3>

<p>The following code is the declaration of an example generator function.</p>

<pre class="brush: js notranslate">function* countAppleSales () {
  let saleList = [3, 7, 5]
  for (let i = 0; i &lt; saleList.length; i++) {
    yield saleList[i]
  }
}</pre>

<p>Once a generator function is defined, it can be used by constructing an iterator as shown.</p>

<pre class="brush: js notranslate">let appleStore = countAppleSales()  // Generator { }
console.log(appleStore.next())      // { value: 3, done: false }
console.log(appleStore.next())      // { value: 7, done: false }
console.log(appleStore.next())      // { value: 5, done: false }
console.log(appleStore.next())      // { value: undefined, done: true }</pre>

<p>You can also send a value with next(value) into the generator. 'step' evaluates as a return value in this syntax [<var>rv</var>] = <strong>yield</strong> [<var>expression</var>]</p>

<pre class="brush: js notranslate">function* counter(value) {
 let step;

 while (true) {
   step = yield ++value;

   if (step) {
     value += step;
   }
 }
}

const generatorFunc = counter(0);
console.log(generatorFunc.next().value);   // 1
console.log(generatorFunc.next().value);   // 2
console.log(generatorFunc.next().value);   // 3
console.log(generatorFunc.next(10).value); // 14
console.log(generatorFunc.next().value);   // 15
console.log(generatorFunc.next(10).value); // 26</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#prod-YieldExpression', 'Yield')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.yield")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/The_Iterator_protocol">The Iterator protocol</a></li>
 <li>{{jsxref("Statements/function*", "function*")}}</li>
 <li>{{jsxref("Operators/function*", "function* expression")}}</li>
 <li>{{jsxref("Operators/yield*", "yield*")}}</li>
</ul>
